%if 0%{?rhel} == 6 || 0%{?rhel} == 7
%global python python
%else
%global __python %{__python3}
%global python python3
%endif

Summary: Key fingerprinting tools for CVE-2017-15361
Name: roca-detect
Version: 1.2.1
Release: 4%{?dist}
Source0: https://github.com/crocs-muni/roca/archive/v%{version}.tar.gz#/%{name}-%{version}.tar.gz
# Remove coloredlogs dependency as it is not in Fedora as of f28
Patch0: roca-detect-color.patch
License: MIT

# NOTE: no python2-pgpdump in Fedora or epel
Requires: %{python}-future %{python}-cryptography %{python}-pgpdump
%if 0%{?rhel} <= 7
Requires: python-dateutil
%else
Requires: %{python}-dateutil
%endif
BuildRequires: %{python}-future %{python}-cryptography %{python}-pgpdump 
BuildRequires: %{python}-setuptools %{python}-devel
BuildArch: noarch
Url: https://crocs.fi.muni.cz/public/papers/rsa_ccs17

%description
This tool is related to the [ACM CCS 2017 conference paper #124 Return of the
Coppersmith’s Attack: Practical Factorization of Widely Used RSA
Moduli](https://crocs.fi.muni.cz/public/papers/rsa_ccs17).

Install this to test public RSA keys for the presence of the vulnerability
described by CVE-2017-15361.

%prep
%setup -q -n roca-%{version}
%patch0 -p0 -b .color

%build
%py_build	# Fails with "fg: no job control"
#{__python} setup.py build

%install
%py_install	# Fails with "fg: no job control"
#{__python} setup.py install --single-version-externally-managed -O1 --root=%{buildroot}

# Replace complex "EASY" universal wrapper with
# dirt simple distro specific wrapper
cat >%{buildroot}%{_bindir}/roca-detect-tls <<'EOF'
#!%{__python}
if __name__ == '__main__':
    import sys,roca.detect
    sys.exit(roca.detect.main())
EOF

ln -sf %{_bindir}/roca-detect-tls %{buildroot}%{_bindir}/roca-detect

%check
%{__python} -m unittest discover

%files
%license LICENSE
%doc README.md docs
%{_bindir}/roca-detect*
%{python_sitelib}/roca
%{python_sitelib}/roca_detect-%{version}*

%changelog
* Tue Sep  4 2018 Stuart D. Gathman <stuart@gathman.org> 1.2.1-4
- More changes from package review:
- Keep upstream introducer name and symlink to it
- Specify an additional directory level after sitelib in files

* Mon Sep  3 2018 Stuart D. Gathman <stuart@gathman.org> 1.2.1-3
- More suggestions from package review

* Mon Sep  3 2018 Stuart D. Gathman <stuart@gathman.org> 1.2.1-2
- Change more nits from Fedora package review

* Mon Sep  3 2018 Stuart D. Gathman <stuart@gathman.org> 1.2.1-1
- py3 support
- New upstream release

* Thu Oct 19 2017 Stuart D. Gathman <stuart@gathman.org> 1.0.7-3
- SPEC file nits from Fedora package review

* Wed Oct 18 2017 Stuart D. Gathman <stuart@gathman.org> 1.0.7-2
- Ditch the "EASY" introducer that requires setuptools >= 1.0

* Wed Oct 18 2017 Stuart D. Gathman <stuart@gathman.org> 1.0.7-1
- Initial rpm
